"""Description of chemical elements"""

MASSES = (
    0, 1.007825, 4.0026, 7.01600, 9.01218, 11.00931,
    12.0, 14.00307, 15.99491, 18.99840, 19.99244,
    22.9898, 23.98504, 26.98153, 27.97693,
    30.97376, 31.97207, 34.96885, 39.948,
    38.96371, 39.96259, 44.95592, 47.90, 50.9440,
    51.9405, 54.9381, 55.9349, 58.9332, 57.9353,
    62.9298, 63.9291, 68.9257, 73.9219, 74.9216,
    79.9165, 78.9183, 83.9115,
    84.9117, 87.9056, 89.9054, 89.9043, 92.9060,
    97.9055, 97.0, 101.9037, 102.9048, 105.9032,
    106.9041, 113.9036, 114.9041, 119.9022,
    120.9038, 129.9067, 126.9044, 131.9042,
    132.9054, 137.9052, 138.9063, 139.9054,
    140.9076, 141.9077, 144.9127, 151.9197,
    152.9212, 157.9241, 158.9253, 163.9292,
    164.9303, 165.9303, 168.9342, 173.9389,
    174.9408, 179.9465, 180.9480, 183.9509,
    186.9557, 191.9615, 192.9629, 194.9648,
    196.9665, 201.9706, 204.9744, 207.9766, 208.9804, 208.9824,
    209.9871, 222.0176, 223.0197, 226.0254,
    227.0278, 232.0381, 231.0359, 238.0508,
    237.0482, 244.0642, 243.0614, 247.0703,
    247.0703, 251.0796, 252.0829, 257.0751,
    258.0986, 259.1009, 260.1053, 261.1087, 0.0, 0.0)

ELEMENTS_NAME = (
    None,
    'H ', 'He', 'Li', 'Be', 'B ', 'C ',
    'N ', 'O ', 'F ', 'Ne', 'Na', 'Mg', 'Al', 'Si', 'P ', 'S ',
    'Cl', 'Ar', 'K ', 'Ca', 'Sc', 'Ti', 'V ', 'Cr', 'Mn', 'Fe',
    'Co', 'Ni', 'Cu', 'Zn', 'Ga', 'Ge', 'As', 'Se', 'Br', 'Kr',
    'Rb', 'Sr', 'Y ', 'Zr', 'Nb', 'Mo', 'Tc', 'Ru', 'Rh', 'Pd',
    'Ag', 'Cd', 'In', 'Sn', 'Sb', 'Te', 'I ', 'Xe', 'Cs', 'Ba',
    'La', 'Ce', 'Pr', 'Nd', 'Pm', 'Sm', 'Eu', 'Gd', 'Tb', 'Dy',
    'Ho', 'Er', 'Tm', 'Yb', 'Lu', 'Hf', 'Ta', 'W ', 'Re', 'Os',
    'Ir', 'Pt', 'Au', 'Hg', 'Tl', 'Pb', 'Bi', 'Po', 'At', 'Rn',
    'Fr', 'Ra', 'Ac', 'Th', 'Pa', 'U ', 'Np', 'Pu', 'Am', 'Cm',
    'Bk', 'Cf', 'Es', 'Fm', 'Md', 'No', 'Lr', 'Rf', 'Db', 'Sg',
    'Bh', 'Hs', 'Mt', 'Ds')

ELEMENTS_LONG_NAME = (
    None,
    'hydrogen', 'helium', 'lithium', 'beryllium', 'boron', 'carbon', 'nitrogen', 'oxygen',
    'fluorine', 'neon', 'sodium', 'magnesium', 'aluminium', 'silicon', 'phosphorus', 'sulfur',
    'chlorine', 'argon', 'potassium', 'calcium', 'scandium', 'titanium', 'vanadium', 'chromium',
    'manganese', 'iron', 'cobalt', 'nickel', 'copper', 'zinc', 'gallium', 'germanium',
    'arsenic', 'selenium', 'bromine', 'krypton', 'rubidium', 'strontium', 'yttrium', 'zirconium',
    'niobium', 'molybdenum', 'technetium', 'ruthenium', 'rhodium', 'palladium', 'silver', 'cadmium',
    'indium', 'tin', 'antimony', 'tellurium', 'iodine', 'xenon', 'caesium', 'barium',
    'lanthanum', 'cerium', 'praseodymium', 'neodymium',
    'promethium', 'samarium', 'europium', 'gadolinium', 'terbium', 'dysprosium', 'holmium', 'erbium',
    'thulium', 'ytterbium', 'lutetium', 'hafnium', 'tantalum', 'tungsten', 'rhenium', 'osmium',
    'iridium', 'platinum', 'gold', 'mercury', 'thallium', 'lead', 'bismuth', 'polonium',
    'astatine', 'radon', 'francium', 'radium', 'actinium', 'thorium', 'protactinium', 'uranium',
    'neptunium', 'plutonium', 'americium', 'curium',
    'berkelium', 'californium', 'einsteinium', 'fermium',
    'mendelevium', 'nobelium', 'lawrencium', 'rutherfordium',
    'dubnium', 'seaborgium', 'bohrium', 'hassium', 'meitnerium', 'darmstadtium')

ELEMENTS = (
    {
        'name': ELEMENTS_NAME[i],
        'long_name': ELEMENTS_LONG_NAME[i],
        'mass': MASSES[i]
    }
    for i in range(len(ELEMENTS_NAME))
)

SYMBOL_MAP_1 = {
    "HYDROGEN": 1, "H": 1, "1": 1, 1: 1,
    "HELIUM": 2, "He": 2, "HE": 2, "2": 2, 2: 2,
    "LITHIUM": 3, "Li": 3, "LI": 3, "3": 3, 3: 3,
    "BERYLLIUM": 4, "Be": 4, "BE": 4, "4": 4, 4: 4,
    "BORON": 5, "B": 5, "5": 5, 5: 5,
    "CARBON": 6, "C": 6, "6": 6, 6: 6,
    "NITROGEN": 7, "N": 7, "7": 7, 7: 7,
    "OXYGEN": 8, "O": 8, "8": 8, 8: 8,
    "FLUORINE": 9, "F": 9, "9": 9, 9: 9,
    "NEON": 10, "Ne": 10, "NE": 10, "10": 10, 10: 10,
    "SODIUM": 11, "Na": 11, "NA": 11, "11": 11, 11: 11,
    "MAGNESIUM": 12, "Mg": 12, "MG": 12, "12": 12, 12: 12,
    "ALUMINUM": 13, "Al": 13, "AL": 13, "13": 13, 13: 13,
    "SILICON": 14, "Si": 14, "SI": 14, "14": 14, 14: 14,
    "PHOSPHORUS": 15, "P": 15, "15": 15, 15: 15,
    "SULFUR": 16, "S": 16, "16": 16, 16: 16,
    "CHLORINE": 17, "Cl": 17, "CL": 17, "17": 17, 17: 17,
    "ARGON": 18, "Ar": 18, "AR": 18, "18": 18, 18: 18,
    "POTASSIUM": 19, "K": 19, "19": 19, 19: 19,
    "CALCIUM": 20, "Ca": 20, "CA": 20, "20": 20, 20: 20,
    "SCANDIUM": 21, "Sc": 21, "SC": 21, "21": 21, 21: 21,
    "TITANIUM": 22, "Ti": 22, "TI": 22, "22": 22, 22: 22,
    "VANADIUM": 23, "V": 23, "23": 23, 23: 23,
    "CHROMIUM": 24, "Cr": 24, "CR": 24, "24": 24, 24: 24,
    "MANGANESE": 25, "Mn": 25, "MN": 25, "25": 25, 25: 25,
    "IRON": 26, "Fe": 26, "FE": 26, "26": 26, 26: 26,
    "COBALT": 27, "Co": 27, "CO": 27, "27": 27, 27: 27,
    "NICKEL": 28, "Ni": 28, "NI": 28, "28": 28, 28: 28,
    "COPPER": 29, "Cu": 29, "CU": 29, "29": 29, 29: 29,
    "ZINC": 30, "Zn": 30, "ZN": 30, "30": 30, 30: 30,
    "GALLIUM": 31, "Ga": 31, "GA": 31, "31": 31, 31: 31,
    "GERMANIUM": 32, "Ge": 32, "GE": 32, "32": 32, 32: 32,
    "ARSENIC": 33, "As": 33, "AS": 33, "33": 33, 33: 33,
    "SELENIUM": 34, "Se": 34, "SE": 34, "34": 34, 34: 34,
    "BROMINE": 35, "Br": 35, "BR": 35, "35": 35, 35: 35,
    "KRYPTON": 36, "Kr": 36, "KR": 36, "36": 36, 36: 36,
    "RUBIDIUM": 37, "Rb": 37, "RB": 37, "37": 37, 37: 37,
    "STRONTIUM": 38, "Sr": 38, "SR": 38, "38": 38, 38: 38,
    "YTTRIUM": 39, "Y": 39, "39": 39, 39: 39,
    "ZIRCONIUM": 40, "Zr": 40, "ZR": 40, "40": 40, 40: 40,
    "NIOBIUM": 41, "Nb": 41, "NB": 41, "41": 41, 41: 41,
    "MOLYBDENUM": 42, "Mo": 42, "MO": 42, "42": 42, 42: 42,
    "TECHNETIUM": 43, "Tc": 43, "TC": 43, "43": 43, 43: 43,
    "RUTHENIUM": 44, "Ru": 44, "RU": 44, "44": 44, 44: 44,
    "RHODIUM": 45, "Rh": 45, "RH": 45, "45": 45, 45: 45,
    "PALLADIUM": 46, "Pd": 46, "PD": 46, "46": 46, 46: 46,
    "SILVER": 47, "Ag": 47, "AG": 47, "47": 47, 47: 47,
    "CADMIUM": 48, "Cd": 48, "CD": 48, "48": 48, 48: 48,
    "INDIUM": 49, "In": 49, "IN": 49, "49": 49, 49: 49,
    "TIN": 50, "Sn": 50, "SN": 50, "50": 50, 50: 50,
    "ANTIMONY": 51, "Sb": 51, "SB": 51, "51": 51, 51: 51,
    "TELLURIUM": 52, "Te": 52, "TE": 52, "52": 52, 52: 52,
    "IODINE": 53, "I": 53, "53": 53, 53: 53,
    "XENON": 54, "Xe": 54, "XE": 54, "54": 54, 54: 54,
    "CESIUM": 55, "Cs": 55, "CS": 55, "55": 55, 55: 55,
    "BARIUM": 56, "Ba": 56, "BA": 56, "56": 56, 56: 56,
    "LANTHANUM": 57, "La": 57, "LA": 57, "57": 57, 57: 57,
    "CERIUM": 58, "Ce": 58, "CE": 58, "58": 58, 58: 58,
    "PRASEODYMIUM": 59, "Pr": 59, "PR": 59, "59": 59, 59: 59,
    "NEODYMIUM": 60, "Nd": 60, "ND": 60, "60": 60, 60: 60,
    "PROMETHIUM": 61, "Pm": 61, "PM": 61, "61": 61, 61: 61,
    "SAMARIUM": 62, "Sm": 62, "SM": 62, "62": 62, 62: 62,
    "EUROPIUM": 63, "Eu": 63, "EU": 63, "63": 63, 63: 63,
    "GADOLINIUM": 64, "Gd": 64, "GD": 64, "64": 64, 64: 64,
    "TERBIUM": 65, "Tb": 65, "TB": 65, "65": 65, 65: 65,
    "DYSPROSIUM": 66, "Dy": 66, "DY": 66, "66": 66, 66: 66,
    "HOLMIUM": 67, "Ho": 67, "HO": 67, "67": 67, 67: 67,
    "ERBIUM": 68, "Er": 68, "ER": 68, "68": 68, 68: 68,
    "THULIUM": 69, "TM": 69, "69": 69, 69: 69,
    "YTTERBIUM": 70, "Yb": 70, "YB": 70, "70": 70, 70: 70,
    "LUTETIUM": 71, "Lu": 71, "LU": 71, "71": 71, 71: 71,
    "HAFNIUM": 72, "Hf": 72, "HF": 72, "72": 72, 72: 72,
    "TANTALUM": 73, "Ta": 73, "TA": 73, "73": 73, 73: 73,
    "TUNGSTEN": 74, "W": 74, "74": 74, 74: 74,
    "RHENIUM": 75, "Re": 75, "RE": 75, "75": 75, 75: 75,
    "OSMIUM": 76, "Os": 76, "OS": 76, "76": 76, 76: 76,
    "IRIDIUM": 77, "Ir": 77, "IR": 77, "77": 77, 77: 77,
    "PLATINUM": 78, "Pt": 78, "PT": 78, "78": 78, 78: 78,
    "GOLD": 79, "Au": 79, "AU": 79, "79": 79, 79: 79,
    "MERCURY": 80, "Hg": 80, "HG": 80, "80": 80, 80: 80,
    "THALLIUM": 81, "Tl": 81, "TL": 81, "81": 81, 81: 81,
    "LEAD": 82, "Pb": 82, "PB": 82, "82": 82, 82: 82,
    "BISMUTH": 83, "Bi": 83, "BI": 83, "83": 83, 83: 83,
    "POLONIUM": 84, "Po": 84, "PO": 84, "84": 84, 84: 84,
    "ASTATINE": 85, "At": 85, "AT": 85, "85": 85, 85: 85,
    "RADON": 86, "Rn": 86, "RN": 86, "86": 86, 86: 86,
    'Fr': 87, "87": 87, 87: 87,
    'Ra': 88, "88": 88, 88: 88,
    'Ac': 89, "89": 89, 89: 89,
    'Th': 90, "90": 90, 90: 90,
    'Pa': 91, "91": 91, 91: 91,
    'U': 92, "92": 92, 92: 92,
    'Np': 93, "93": 93, 93: 93,
    'Pu': 94, "94": 94, 94: 94,
    'Am': 95, "95": 95, 95: 95,
    'Cm': 96, "96": 96, 96: 96,
    'Bk': 97, "97": 97, 97: 97,
    'Cf': 98, "98": 98, 98: 98,
    'Es': 99, "99": 99, 99: 99,
    'Fm': 100, "100": 100, 100: 100,
    'Md': 101, "101": 101, 101: 101,
    'No': 102, "102": 102, 102: 102,
    'Lr': 103, "103": 103, 103: 103,
    'Rf': 104, "104": 104, 104: 104,
    'Db': 105, "105": 105, 105: 105,
    'Sg': 106, "106": 106, 106: 106,
    'Bh': 107, "107": 107, 107: 107,
    'Hs': 108, "108": 108, 108: 108,
    'Mt': 109, "109": 109, 109: 109,
    'Ds': 110, "110": 110, 110: 110,
    'Rg': 111, "111": 111, 111: 111,
    'Cn': 112, "112": 112, 112: 112,
    'Nh': 113, "113": 113, 113: 113,
    'Fl': 114, "114": 114, 114: 114,
    'Mc': 115, "115": 115, 115: 115,
    'Lv': 116, "116": 116, 116: 116,
    'Ts': 117, "117": 117, 117: 117,
    'Og': 118, "118": 118, 118: 118,
    'Uue': 119, "119": 119, 119: 119,
}

SYMBOL_MAP = {}
for key, value in SYMBOL_MAP_1.items():
    SYMBOL_MAP[key] = value
    if isinstance(key, str):
        SYMBOL_MAP[key.lower()] = value

    if isinstance(key, int):
        SYMBOL_MAP[f'{key:.1f}'] = value

